## Backtrace-Similiarity

Backtrace service for callstack similarity and merge recommendations

---

## Development
To watch for Typescript changes:  
`npm install`  
`npm run watch-tsc`  
 
In another tab, watch for dist folder changes:  
`npm run watch-dist`  
which will reload server after Typescript recompiles.  

If you get this error: `[nodemon] Internal watch failed: ENOSPC: System limit for number of file watchers reached` you don't have enough watchers configured. Try this:  
`echo fs.inotify.max_user_watches=524288 | sudo tee -a /etc/sysctl.conf && sudo sysctl -p`  

A Postman collection is available to see shape of requests.    


Distance parameters: 
```    
"candidacy": [
        {
            "type": "distance",
            "threshold": 5     // minimum callstack length to be considered
            "truncate": 50,    // shorten the callstack before comparing
            "intersection": 3, // callstacks need to have at least n frames in common
            "distance": 5,     // minimum distance to be considered a candidate
        }
    ],
```

`intersection` and `distance` parameters can also take the string "dynamic" instead of an integer. The service will then calculate appropriate values based on callstack.  

---
#### Config

See `similiarity.conf` for configuration.  

`clusterSupport` is the number of clusters the service will run with overall.  
`requestWorkers` controls the number of worker threads for callstack processing.
`logQueries` is a boolean that will log /api/query query and responses at debug level
---
